#include <cstdio>

int n;
int a[1024][1024];
int d[1024][1024];

void read()
{
    int i,j;
    
    scanf ("%d",&n);
    
    for (i=1;i<=n;i++)
    {
        for (j=1;j<=n;j++)
        {
            scanf ("%d",&a[i][j]);
        }
    }
}

void print ( int t , int j)
{
    if ( t < 0 )
    {
        if ( !(t/10) ) printf ("  %d",t);
        else
        if ( !(t/100) ) printf (" %d",t);
        else
        if ( !(t/1000) ) printf ("%d",t);
        else
        printf ("%d",t);
        if ( j != n ) printf (" ");
    }
    else
    {
        if ( !(t/10) ) printf ("   %d",t);
        else
        if ( !(t/100) ) printf ("  %d",t);
        else
        if ( !(t/1000) ) printf (" %d",t);
        else
        if ( !(t/10000) ) printf ("%d",t);
        if ( j != n ) printf (" ");
    }
}

int go ( int i, int j )
{
 //   printf ("%d %d\n",i,j);
    if (i==0 || j == 0 || i == n+1 || j == n +1 ) return -1000;
    
    if ( d[i][j] != -(1<<30) ) return d[i][j];
    int best = 0;
    int k;
    
    for (k=j;k>=1;k--)
    if ( d[i][k] != -(1<<30) ) 
    {
        best >?= d[i][k];
        break;
    }
    else best >?= a[i][k];
    
    best >?= go (i-1,j-1);
    best >?= go (i+1,j-1);
    
    return d[i][j] = (best);
}

void solve()
{
    int i,j;
    
    for (i=1;i<=n;i++)
    for (j=1;j<=n;j++) d[i][j] = -(1<<30);
    
    for (i=1;i<=n;i++)
        for (j=1;j<=n;j++)
        {
          //  go(i,j);
            print ( go (i,j) ,j );
            if ( j == n )
            printf ("\n");
        }
}

int main()
{
    read();
    solve();
    
    return 0;
}
