#include <cstdio>
#include <algorithm>
#include <vector>
using namespace std;

int n,m,k;
int a[128][128];
int used[128];
int pp[128];
int pos;
vector <int> e[128];
int ans;

void read()
{
    scanf ("%d%d%d",&n,&m,&k);
    int i;
    int x,y;
    
    for (i=0;i<m;i++)
    {
        scanf ("%d%d",&x,&y);
        a[x][y] = a[y][x] = 1;
        e[x].push_back(y);
        e[y].push_back(x);
    }
}

void dfs ( int node , int len )
{
    if ( len == k )
    {
        ++ ans;
      //  printf ("%d\n",node);
        return ;
    }
    
    int i,k;
    int sz = e[node].size();
    int t;
    int l;
    
    for (i=0;i<sz;i++)
    {
        t = e[node][i];
        if ( !used[t] && t > node )
        {
            l = 0;
            for (k=0;k<pos;k++)
            {
                if ( !a[ pp[k] ][ t ] ) l = 1;
            }
            if ( !l )
            {
                used[t] = 1;
                pp[pos++] = t;
                dfs(t,len+1);
                used[t] = 0;
                pp[--pos] = 0;
            }
        }
    }
}

void solve()
{
    int i,k;
    
    for (i=1;i<=n;i++)
    {
        used[i] = 1;
        pp[pos++] = i;
        dfs( i , 1 );
        used[i] = 0;
        pp[--pos] = 0;
    }
    
    printf ("%d\n",ans);
}

int main()
{
    read();
    solve();
    
    return 0;
}
