#include <iostream>
#include <vector>
using namespace std;

int n,k;
vector<int> a[10005];
int used[10005];

void init()
{  int m;
   cin >> n >> m;
   for(int u=1; u<=n; u++)  used[u]=0;  

   for(int i=1; i<=m; i++)
   { int u,v;
     cin >> u >> v;
     a[u].push_back(v);
     a[v].push_back(u);
   }  
}

void dfs(int u)
{  k++;
   used[u] = 1;    
   for(int i=0; i<a[u].size(); i++)
   { int v = a[u][i];
     if(used[v] == 0) 
       dfs(v);
   }
}


int main()
{ init();
  
  for(int u=1; u<=n; u++)
    if(a[u].size() == 0)
    { cout << "Isolated vertex" << endl; 
      return 0;
    }  

  k=0;
  dfs(1);
  if(k < n)
  { cout << "Disconnected" << endl; 
    return 0;
  }  
  
    
  for(int u=1; u<=n; u++)
    if(a[u].size()%2 == 1)
    { cout << "Non-even vertex" << endl; 
      return 0;
    }  
    
  cout << "YES" << endl;
  return 0;  
}   
