#include <cstdio>
#include <algorithm>
#include <vector>
using namespace std;

int n,m;
vector < int > a[1024];
vector < pair <int,int> > e;
int used[1024];
int o,p;

void read()
{
    scanf ("%d",&n);
    int t,y;
    int i;
    int x;
    
    while (1)
    {
        scanf ("%d",&t);
        
        if ( t == 0 ) break;
        
        while(1)
        {
            scanf ("%d",&y);
            
            if ( !y ) break;
            
            a[t].push_back(y);
            e.push_back(make_pair(t,y));
            ++m;
        }
    }
}

void dfs ( int node )
{
    used[node] = 1;
    
    int i;
    int sz = a[node].size();
    int t;
    
    for (i=0;i<sz;i++)
    {
        t = a[node][i];
        if ( ( node == o && t == p ) || ( node == p && t == o ) ) continue;
        if ( !used[ t ] )
        {
            dfs(t);    
        }
    }
}

void solve()
{
    int i,j;
    int ans = 0;
    int l;
    int bsk = 0;
    
    for (i=1;i<=n;i++)
    {
        o = -1;
        p = -1;
        if ( !used[i] )
        {
            dfs(i);
            ++bsk;
        }
    }
    
    for(i=0;i<=n+1;i++) used[i] = 0;
    
    int cur;
    
    for (i=0;i<m;i++)
    {
        o = e[i].first;
        p = e[i].second;
        l = 0;
        cur = 1;
        
        dfs(1);
        
        for (j=1;j<=n;j++)
        {
            if (!used[j])
            {
                dfs(j);
                cur++;
            }
        }
        for (j=1;j<=n;j++) used[j] = 0;
        
        if ( cur > bsk ) ans ++;
    }
    
    printf ("%d\n",ans/2);
}

int main()
{
    read();
    solve();
    
    return 0;
}
