#include <cstdio>
#include <algorithm>
#include <vector>
#include <map>
using namespace std;

int n,m;
int a[16];
vector < vector < int > > dp[256];

void read()
{
    scanf ("%d%d",&n,&m);
    int i;
    
    for (i=1;i<=n;i++)
    {
        scanf ("%d",&a[i]);
    }
}

int cmp( vector < int > q , vector < int > w )
{
    map < int , int > fst;
    map < int , int > snd;
    
    int i;
    int r = q.size();
    int t = w.size();
    int p1 , p2;
    
    for (i=0;i<min(r,t);i++)
    {
        p1 = fst[q[i]];
        p2 = snd[w[i]];
        
        for (;p1<n;p1++)
        {
            if ( a[p1] == q[i] )
            {
                break;
            }
        }
        fst[q[i]] = p1;
        for (;p2<n;p2++)
        {
            if ( a[p2] == w[i] )
            {
                break;
            }
        }
        snd[w[i]] = p2;
        
        if ( p1 < p2 ) return 1;
        if ( p2 < p1 ) return 0;
    }
    
    if ( q.size() < w.size() ) return 1;
    return 0;
}

void solve()
{
    int i,j,k,d;
    int t;
    vector <int> tmp;
    
    dp[0].push_back(tmp);
    
    for (i=1;i<=n;i++)
    {
        t = a[i];
        for (j=m;j>=t;j--)
        {
            if ( dp[j-t].size() > 0 )
            {
                for (k=0;k<dp[j-t].size();k++)
                {
                    tmp = dp[j-t][k];
                    tmp.push_back(t);
                    dp[j].push_back(tmp);
                }
            }
        }
    }
    
    t = dp[m].size();
    
    if ( t == 0 ) printf ("no solution\n");
    else
    {
        sort ( dp[m].begin() , dp[m].end() , cmp );
        for (k=0;k<t;k++)
        {
            for (d=0;d<int(dp[m][k].size())-1;d++)
            {
                printf ("%d ",dp[m][k][d]);
            }
            printf ("%d\n",dp[m][k][d]);
        }
    }
}

int main()
{
    read();
    solve();
    
    return 0;
}
