#include <cstdio>
#include <algorithm>
#include <vector>
using namespace std;

int n;
vector < int > a[1024];
int used[1024];

void read()
{
    int m;
    scanf ("%d%d",&n,&m);
    int i;
    int x,y;
    
    for (i=1;i<=m;i++)
    {
        scanf ("%d%d",&x,&y);

        a[x].push_back(y);
        a[y].push_back(x);
    }
}

void dfs ( int node )
{
    used[node] = 1;
    
    int i;
    int sz = a[node].size();
    
    for (i=0;i<sz;i++)
    {
        if ( !used[ a[node][i] ] )
        {
            dfs(a[node][i]);
        }
    }
}

void solve()
{
    int ans = 1;
    int i;
    
    for (i=1;i<=n;i++)
    {
        if ( a[i].size() & 1 ) ans = 0;
    }
    
    dfs(1);
    
    for (i=1;i<=n;i++)
    {
        if ( !used[i] ) ans = 0;
    }
    
    if ( ans ) printf ("YES\n");
    else printf ("NO\n");
}

int main()
{
    read();
    solve();
    
    return 0;
}
